"use strict";
cc._RF.push(module, 'c5ce7m+9bhClaJW5Qq+29y/', 'pbkiller');
// Script/pbkiller.js

"use strict";

var ProtoBuf = _interopRequireWildcard(require("protobufjs"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// import ProtoBuf from 'protobufjs';
// let ProtoBuf = require('protobufjs');
ProtoBuf.Util.IS_NODE = cc.sys.isNative;
var cccVer = cc.ENGINE_VERSION.match(/\d+\.\d+/)[0];
ProtoBuf.Util.cccVer = cccVer;

function compareVer(v1, v2) {
  var array1 = v1.split('.').map(function (i) {
    return parseInt(i);
  });
  var array2 = v2.split('.').map(function (i) {
    return parseInt(i);
  });
  var diff = 0;

  for (var i = 0; i < array1.length; i++) {
    diff = array1[i] - array2[i];

    if (diff !== 0) {
      return diff > 0 ? 1 : -1;
    }
  }

  return 0;
}

ProtoBuf.Util.IS_NODE = false;
/**
 * 加载proto
 */

var loadProto = ProtoBuf.loadProto.bind(ProtoBuf);

ProtoBuf.loadProto = function (asset, builder, filename) {
  try {
    if (typeof asset === 'string') {
      loadProto(asset, builder, filename);
    } else if (asset.text) {
      loadProto(asset.text, builder, filename);
    }
  } catch (e) {
    cc.warn(filename + ": protobuf syntax error");
  }
};
/**
 * 加载json文件 
 */


ProtoBuf.loadJsonFile = function (filename, callback, builder) {
  if (callback && typeof callback === 'object') builder = callback, callback = null;else if (!callback || typeof callback !== 'function') callback = null;
  if (callback) return ProtoBuf.Util.fetch(typeof filename === 'string' ? filename : filename["root"] + "/" + filename["file"], function (contents) {
    if (contents === null) {
      callback(Error("Failed to fetch file"));
      return;
    }

    try {
      callback(null, ProtoBuf.loadJson(JSON.parse(contents), builder, filename));
    } catch (e) {
      callback(e);
    }
  });
  var url = typeof filename === 'object' ? filename["root"] + "/" + filename["file"] : filename;
  var json;

  if (ProtoBuf.preloaded) {
    var content = cc.loader.getRes(url, cc.JsonAsset);

    if (content) {
      json = cc.JsonAsset ? content.json : content;
    }
  } else {
    var _content = ProtoBuf.Util.fetch(url);

    if (_content) {
      json = JSON.parse(_content);
    }
  }

  return json ? ProtoBuf.loadJson(json, builder, filename) : null;
};

module.exports = {
  root: 'pb',
  preload: function preload(cb) {
    ProtoBuf.Util.fetch = cc.loader.getRes.bind(cc.loader);
    cc.resources.loadDir(this.root, function (error, data) {
      ProtoBuf.preloaded = !error;
      cb();
    });
  },

  /**
   * 加载文件proto文件，支持json、proto格式
   * @param {String|Array} files 
   */
  loadFromFile: function loadFromFile(fileNames, packageName) {
    if ((CC_JSB || cc.sys.platform === cc.sys.WECHAT_GAME) && !ProtoBuf.preloaded) {
      cc.error('原生或微信小游戏上，需要先调用preload函数');
      return;
    }

    if (typeof fileNames === 'string') {
      fileNames = [fileNames];
    }

    var builder = ProtoBuf.newBuilder();

    if (compareVer(cccVer, '1.10.0') >= 0 && ProtoBuf.preloaded) {
      builder.importRoot = this.root;
    } else {
      builder.importRoot = cc.url.raw("resources/" + this.root);
    }

    fileNames.forEach(function (fileName) {
      var extname = cc.path.extname(fileName);
      var fullPath = builder.importRoot + "/" + fileName;

      if (cccVer >= 2.4) {
        fullPath = cc.path.mainFileName(fullPath);
      }

      if (extname === '.proto') {
        ProtoBuf.loadProtoFile(fullPath, builder);
      } else if (extname === '.json') {
        ProtoBuf.loadJsonFile(fullPath, builder);
      } else {
        cc.log("nonsupport file extname, only support 'proto' or 'json'");
      }
    });
    return builder.build(packageName);
  },

  /**
   * 加载所有proto文件
   * @param {String} extname 
   * @param {String} packageName 
   */
  loadAll: function loadAll(extname, packageName) {
    if (extname === void 0) {
      extname = 'proto';
    }

    if (packageName === void 0) {
      packageName = '';
    }

    var files = [];

    if (this.root.endsWith('/') || this.root.endsWith('\\')) {
      this.root = this.root.substr(0, this.root.length - 1);
    } //获取this.root下的所有文件名


    var infos = cc.resources.getDirWithPath(this.root);

    for (var index = 0; index < infos.length; index++) {
      var path = infos[index].path.substr(this.root.length + 1) + ".json";
      files.push(path);
    } // cc.loader._assetTables["assets"].getUuidArray(this.root, null, files);
    // files = files.map((filePath) => {
    //     let str = filePath.substr(this.root.length + 1);
    //     return `${str}.${extname}`;
    // });


    return this.loadFromFile(files, packageName);
  },
  loadData: function loadData(url, callback) {
    if (CC_JSB) {
      var data = jsb.fileUtils.getDataFromFile(url);
      setTimeout(function () {
        callback(data);
      }, 0);
    } else {
      var xhr = ProtoBuf.Util.XHR();
      xhr.open('GET', url, true);
      xhr.setRequestHeader('Accept', 'text/plain');
      xhr.responseType = 'arraybuffer';
      if (typeof xhr.overrideMimeType === 'function') xhr.overrideMimeType('text/plain');

      if (callback) {
        xhr.onreadystatechange = function () {
          if (xhr.readyState != 4) return;
          if (
          /* remote */
          xhr.status == 200 ||
          /* local */
          xhr.status == 0) callback(xhr.response);else callback(null);
        };

        if (xhr.readyState == 4) return;
        xhr.send(null);
      }
    }
  }
};

cc._RF.pop();